# -*- ruby -*-

#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-10-04 12:45:54 +0900 (Sat, 04 Oct 2003) $
#   $LastChangedBy: sugi $
#

module VFS;  module SchemeHandler;  module FILE;
  module Common

    def initialize(url)
      super
      if Regexp.new("^file://[^/]+/").match(url)
	raise Error::InvalidURI,
	  %Q{"file://*remote-host*/path" style is not supported.}
      elsif Regexp.new("^(?:file:(?://(?=/))?)?(.+)").match(url)
	@real_path = $1
      else
	raise Error::InvalidURI,
	  %Q{invalid URI '#{url}' was specicied}
      end
    end
    attr_reader :real_path

  end # Common

  module MethodGenerator
    include VFS::MethodGenerator
    private
    def relay_realpath_to_file_builtin(*symbols)
      gen_delegate_method([:FileBuiltIn,
			  "*arg, &block",
			  "real_path, *arg, &block"],
			  *symbols)
    end

    def relay_realpath_to_dir_builtin(*symbols)
      gen_delegate_method([:DirBuiltIn,
			  "*arg, &block",
			  "real_path, *arg, &block"],
			  *symbols)
    end
  end # MethodGenerator
end; end; end
