# -*- ruby -*-

#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-10-04 15:28:53 +0900 (Sat, 04 Oct 2003) $
#   $LastChangedBy: sugi $
#

require 'vfs/file'
require 'vfs/scheme/file/common'

module VFS;  module SchemeHandler; module FILE;
  class File < VFS::File
    include VFS::SchemeHandler::FILE::Common
    extend  VFS::SchemeHandler::FILE::MethodGenerator

    relay_realpath_to_file_builtin :size?,
      :chmod, :chardev?, :zero?, :writable_real?, :umask,
      :atime, :pipe?, :exists?, :symlink, :sticky?, :file?, :stat,
      :blockdev?, :writable?, :ftype, :foreach,
      :grpowned?, :exist?, :link, :setgid?, :executable_real?,
      :delete, :ctime, :socket?, :readable_real?, :truncate, :unlink,
      :lstat, :owned?, :directory?, :chown, :setuid?, :executable?,
      :expand_path, :mtime, :symlink?, :size, :readable?, :readlink

    undef :buf, :open_as_read, :open_as_write
    def open(*arg, &block)
      FileBuiltIn.open(real_path, *arg, &block)
    end

    def rename_internal(to)
      FileBuiltIn.rename(real_path, to)
      VFS::File.new(to)
    end

    def utime(n_atime, n_mtime)
      FileBuiltIn.utime(n_atime, n_mtime, real_path)
    end
  end # VFS::SchemeHandler::FILE::File
end; end; end

if __FILE__ == $0
  f = "file:///home/sugi/.bashrc"
  vfs = VFS::SchemeHandler::FILE::File.new(f)
  p vfs
  p vfs.join(%w(a b c))
  p VFS::join(%w(a b c))
  p VFS::scheme(f)
  p vfs.scheme
  p vfs.mtime
#  p VFS::SchemeHandler::FILE::File.mtime(f)
  p vfs.basename
  p vfs.dirname
  p vfs.scheme
  io = vfs.open
  puts io.read(20)
  io.close
  vfs.open { |io| puts io.read(20) }
#  io = VFS::SchemeHandler::FILE::File.open(f)
#  puts io.read(20)
#  io.close
#  VFS::SchemeHandler::FILE::File.open(f){ |io| puts io.read(20) }
#  VFS::SchemeHandler::FILE::File.new("/tmp/moge") << ["mogemoge", Time.new]
end
